#include <SoftwareSerial.h>
#include <SPI.h>
#include <SD.h>
#include <Q2HX711.h>
      const byte hx711_data_pin = A0;
      const byte hx711_clock_pin = A1;
      float val[20];
      float vol;
      float offst=0;
      Q2HX711 hx711(hx711_data_pin, hx711_clock_pin);
      
      int m=0;
      float inter[7];
      int led=A2;
      int h=0;
      float off[30];

//SD card
      const int chipSelect = 5;

//DC4021BE pin declare
      int latchPin = 9;
      int dataPin = 8;
      int clockPin = 7;

//MAX665 pin declare
      int CLK = 6;
      int CS = 10;
      int pwr=4;

//temperature
      int v = 0;
      float Ctemp, Ftemp;
      byte switchVar[15]; 
      short realVar[7];
      short bin=1; 
      char note2sing[] = {
        'C', 'd', 'e', 'f', 'g', 'a', 'b', 'c'};

//Hall effect flowmeter
        
      byte sensorInterrupt = 0;  // 0 = digital pin 2
      byte sensorPin       = 2;
      // The hall-effect flow sensor outputs approximately 4.5 pulses per second per
      // litre/minute of flow.
      float calibrationFactor = 4.5;
      volatile byte pulseCount;  
      float flowRate;
      unsigned int flowMilliLitres;
      unsigned long totalMilliLitres;
      unsigned long oldTime;
    
      int dq=0;

void setup() 
{
   //start serial
      Serial.begin(9600);
    Serial.println();
    Serial.print("\t");
    int k=0;
    while(k<=5)
    {
    Serial.print("-");
    delay(500);
    k++;
    }
    Serial.print("XXX--STARTING AVELMX VER 1.0 LOGGER--XXX");
    k=0;
    while(k<=5)
    {
    Serial.print("-");
    delay(100);
    k++;
    }
    Serial.println("\t");
    

  
  
   //define pin modes
      pinMode(latchPin, OUTPUT);
      pinMode(clockPin, OUTPUT);
      pinMode(dataPin, INPUT);
      pinMode(CLK, OUTPUT);
      pinMode(CS, OUTPUT);
      pinMode(pwr,OUTPUT);
      pinMode(A3,OUTPUT);
      digitalWrite(CS, HIGH);
      digitalWrite(CLK, LOW);
      digitalWrite(pwr, HIGH);
     

  //For flometer 
      pinMode(sensorPin, INPUT);
      digitalWrite(sensorPin, HIGH);
      pulseCount        = 0;
      flowRate          = 0.0;
      flowMilliLitres   = 0;
      totalMilliLitres  = 0;
      oldTime           = 0;
    
  // The Hall-effect sensor is connected to pin 2 which uses interrupt 0.
  // Configured to trigger on a FALLING state change (transition from HIGH
  // state to LOW state)
        attachInterrupt(sensorInterrupt, pulseCounter, FALLING);
   //for start / stop button
        attachInterrupt(digitalPinToInterrupt(3), emu, RISING);

  //FOR SD card
        Serial.print("Initializing SD card");
        k=0;
    while(k<=7)
    {
    Serial.print("..");
    delay(500);
    k++;
    }
  // see if the card is present and can be initialized:
        if (!SD.begin(chipSelect)) {
        Serial.println("Card failed, or not present");
  // don't do anything more:
        return;
        }else{
        Serial.println("card initialized.");
        pinMode(A2,OUTPUT);
        digitalWrite(A2,HIGH);
        Serial.println("Ready....Press the start button:");
        }
}
  

void loop() 
{ 
  //wait untill a button is pushed
        while((m==0))
        {
          while(h==0)
          {
          for(int i=30; i>=0; i--)
        {
         off[i]=hx711.read();
         if(i<=25){
        off[i]=(hx711.read()/100.0);
        off[i]=0.3245*off[i]-29619.8707+2700;
         offst+=off[i];
         }     
                  }
           h++;
           offst=offst/26;
        }
           delay(100);
         }
		 h==0;
         digitalWrite(A2,LOW);
         File dataFile = SD.open("datalog.txt", FILE_WRITE);
         if (dataFile & dq==0) 
         {
         dataFile.println();
         dataFile.print("DATA ACQUSITION STARTED "); 
         dataFile.println("\t");
         dataFile.close();
         dq++;
          }
       //Record of Sampling time    
         Serial.print((millis())/1000);
         Serial.print("sec");
         Serial.print("\t");
             
            
      //write to sd card too
         if (dataFile) 
         {
         dataFile.print((millis())/1000);
         dataFile.print("sec");
         dataFile.print("\t");
         dataFile.close();
          }
          
      //Temperature reading starts here       
        digitalWrite(CS,LOW);
        delay(2);
        digitalWrite(CS,HIGH);
      //conversion process
        delay(220);
        digitalWrite(CS,LOW);
      //discard bit 15
        digitalWrite(CLK,HIGH);
        delay(1);
        digitalWrite(CLK,LOW);

      //The following loop fetches bit by bit of the remaining 15 bits consecutively and saves it to a 8 bit variable(through the CD4021BE) 
       for (int i=14; i>=0; i--) 
       {
          //set it to 1 to collect parallel data
            digitalWrite(latchPin,1);
          //set it to 1 to collect parallel data
            digitalWrite(CLK,HIGH);
          //wait
            delayMicroseconds(20);
          //set it to 0 to transmit data serially  
            digitalWrite(latchPin,0);
          
            switchVar[i] = shiftIn(dataPin, clockPin);
            
            digitalWrite(CLK,LOW);

          //Trouble shooting statements
          //Serial.println(switchVar[i],BIN);
          //Serial.println("-------------------");
          //delay so all these print satements can keep up.
            delay(100);
       }

  //This loop reconstructs the 15 bit temperature value form the MAX6675
    for (int j=7; j>=4; j--)
    {
        for (int i=0; i<=14; i++)
        {
          if(switchVar[i]&(1<<j))
          {
            realVar[j]|=(bin<<i);
            }
            else{
              realVar[j]&=~(bin<<i);
              }    
          }
          if (realVar[j] & (1<<2)) 
          {
             Serial.print("Nan");
             Serial.print("\t");
             }
             else {
              unsigned int fract;
              inter[j]=0.25*(realVar[j]>>3);
              Serial.print(float(inter[j])); 
              Serial.print("\t");
               
      //sd card  
     File dataFile = SD.open("datalog.txt", FILE_WRITE);             
      //write to sd card too
        if (dataFile) 
        {
           dataFile.print(int(inter[j])); 
           dataFile.print(".");
           dataFile.print(fract, DEC) ;
           dataFile.print("\t");
           dataFile.close();
         }
       // if the file isn't open, pop up an error:
         else {
           Serial.println("error opening datalog.txt");
           Serial.print("Reinitializing SD card...");
        // see if the card is present and can be reinitialized:
           if (!SD.begin(chipSelect)) 
           {
              Serial.println("Reinitialization failed");
        // don't do anything more:
            }
            else{Serial.println("Reinitialization success");}
            }
//                End writing to sd card        
          }
                      delay(100);
    }

    //Blinks a led ; a duration of which tells you if there is a delay and that implies an error
    digitalWrite(A2,HIGH);
    
    if((millis() - oldTime) > 1000)    // Only process counters once per second
      { 
        detachInterrupt(sensorInterrupt);
        flowRate = ((1000.0 / (millis() - oldTime)) * pulseCount); // calibrationFactor
        oldTime = millis();
        flowMilliLitres = (flowRate / 60) * 1000;
     
        totalMilliLitres += flowMilliLitres;
          
        unsigned int frac;
        
        // Print the flow rate for this second in litres / minute
        Serial.print("Flow: ");
        Serial.print(int(flowRate));  // Print the integer part of the variable
        Serial.print(".");             // Print the decimal point
        // Determine the fractional part. The 10 multiplier gives us 1 decimal place.
        frac = (flowRate - int(flowRate)) * 10;
        Serial.print(frac, DEC) ;      // Print the fractional part of the variable
        Serial.print("L/min");

    //weight sensor
        Serial.print("\t");
        vol=0;
        for(int i=20; i>=0; i--)
        {
        val[i]=(hx711.read()/100.0);
        vol=vol+val[i];
        }
        vol=vol/20; 
         //Serial.println(vol); 
        Serial.print(0.3245*vol-29615.8707-offst);
        Serial.println("g");
                
    //sd card  
        File dataFile = SD.open("datalog.txt", FILE_WRITE);
    //write to sd card too
          if (dataFile) 
          {
             dataFile.print(int(flowRate)); 
             dataFile.print(".");
             dataFile.print(frac, DEC) ;      // Print the fractional part of the variable
             dataFile.print("L/min");
             dataFile.print("\t");
             dataFile.print(0.3245*vol-29615.8707-offst);
             dataFile.println("g");
             dataFile.close();
           }
       // if the file isn't open, pop up an error:
            else {
             Serial.println("error opening datalog.txt");
                  }
        //End writing to sd card    
        // Reset the pulse counter so we can start incrementing again
        pulseCount = 0;
        
        // Enable the interrupt again now that we've finished sending output
          attachInterrupt(sensorInterrupt, pulseCounter, FALLING);
        }    
        //delay(27480);
}



byte shiftIn(int myDataPin, int myClockPin) {
  int i;
  int temp = 0;
  int pinState;
  byte myDataIn = 0;

  pinMode(myClockPin, OUTPUT);
  pinMode(myDataPin, INPUT);

  for (i=7; i>=0; i--)
  {
    digitalWrite(myClockPin, 0);
    delayMicroseconds(0.2);
    temp = digitalRead(myDataPin);
    if (temp) {
      pinState = 1;
      //set the bit to 0 no matter what
      myDataIn = myDataIn | (1 << i);
    }
    else {
      //turn it off -- only necessary for debuging
     //print statement since myDataIn starts as 0
      pinState = 0;
    }

    //Debuging print statements
    //Serial.print(pinState);
    //Serial.print(myDataPin);
    //Serial.print("     ");
    //Serial.println (myDataIn, BIN);

    digitalWrite(myClockPin, 1);

  }
  //debuging print statements whitespace
  //Serial.println();
  //Serial.println(myDataIn, BIN);
  return myDataIn;
}
void pulseCounter()
  {
    // Increment the pulse counter
    pulseCount++;
  }
void emu()
  {
    if(m==1)
      {
        m--;
        dq--;
         File dataFile = SD.open("datalog.txt", FILE_WRITE);
         if (dataFile & dq==0) 
         {
         dataFile.print("DATA ACQUSITION STOPPED "); 
         dataFile.println("\t");
         dataFile.close();
         }
        }else{
          m++;
          
        }
      
  }


